package ch.ethz.matsim.projects.astra_2018_002;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import org.matsim.api.core.v01.Scenario;
import org.matsim.api.core.v01.network.Link;

public class ASTRAConfigurator {
	static public void adjustNetwork(Scenario scenario) {
		// TODO: only until we actually assign allowed modes via the pipeline
		for (Link link : scenario.getNetwork().getLinks().values()) {
			Set<String> allowedModes = new HashSet<>(link.getAllowedModes());

			if (allowedModes.contains("car")) {
				allowedModes.addAll(Arrays.asList("prav3", "prav4", "prav5"));
			}

			link.setAllowedModes(allowedModes);
		}
	}
}
