package ch.ethz.matsim.projects.astra_2018_002.shared_av;

import org.matsim.core.config.ReflectiveConfigGroup;

public class SharedAVConfigGroup extends ReflectiveConfigGroup {
	public final static String GROUP_NAME = "shared_avs";

	private final static String USE_SHARED_AVS = "useSharedAVs";
	private final static String TAXI_FLEET_SIZE = "taxiFleetSize";
	private final static String POOLED_FLEET_SIZE = "pooledFleetSize";
	private final static String SERVICE_AREA_ATTRIBUTE = "serviceAreaAttribute";
	private final static String ACTIVE_SERVICE_AREA = "activeServiceArea";
	private final static String SERVICE_AREA_SHAPEFILE = "serviceAreaShapefile";
	private final static String WAITING_TIME_ZONE_SHAPEFILE = "waitingTimeZoneShapefile";
	private final static String WAITING_TIME_ZONE_IDENTIFIER_ATTRIBUTE = "waitingTimeZoneIdentifierAttribute";

	private boolean useSharedAVs = false;

	private int taxiFleetSize = 100;
	private int pooledFleetSize = 0;

	private String serviceAreaAttribute = "OAREA";
	private String activeServiceArea = "ZH";
	private String serviceAreaShapefile = "service_area.shp";

	private String waitingTimeZoneIdentifierAttribute = "WZONE";
	private String waitingTimeZoneShapefile = "waiting_time_areas.shp";

	public SharedAVConfigGroup() {
		super(GROUP_NAME);
	}

	@StringGetter(USE_SHARED_AVS)
	public boolean getUseSharedAVs() {
		return useSharedAVs;
	}

	@StringSetter(USE_SHARED_AVS)
	public void setUseSharedAVs(boolean useSharedAVs) {
		this.useSharedAVs = useSharedAVs;
	}

	@StringGetter(TAXI_FLEET_SIZE)
	public int getTaxiFleetSize() {
		return taxiFleetSize;
	}

	@StringSetter(TAXI_FLEET_SIZE)
	public void setTaxiFleetSize(int taxiFleetSize) {
		this.taxiFleetSize = taxiFleetSize;
	}

	@StringGetter(POOLED_FLEET_SIZE)
	public int getPooledFleetSize() {
		return pooledFleetSize;
	}

	@StringSetter(POOLED_FLEET_SIZE)
	public void setPooledFleetSize(int pooledFleetSize) {
		this.pooledFleetSize = pooledFleetSize;
	}

	@StringGetter(SERVICE_AREA_ATTRIBUTE)
	public String getServiceAreaAttribute() {
		return serviceAreaAttribute;
	}

	@StringSetter(SERVICE_AREA_ATTRIBUTE)
	public void setServiceAreaAttribute(String serviceAreaAttribute) {
		this.serviceAreaAttribute = serviceAreaAttribute;
	}

	@StringGetter(ACTIVE_SERVICE_AREA)
	public String getActiveServiceArea() {
		return activeServiceArea;
	}

	@StringSetter(ACTIVE_SERVICE_AREA)
	public void setActiveServiceArea(String activeServiceArea) {
		this.activeServiceArea = activeServiceArea;
	}

	@StringGetter(SERVICE_AREA_SHAPEFILE)
	public String getServiceAreaShapefile() {
		return serviceAreaShapefile;
	}

	@StringSetter(SERVICE_AREA_SHAPEFILE)
	public void setServiceAreaShapefile(String serviceAreaShapefile) {
		this.serviceAreaShapefile = serviceAreaShapefile;
	}

	@StringGetter(WAITING_TIME_ZONE_SHAPEFILE)
	public String getWaitingTimeZoneShapefile() {
		return waitingTimeZoneShapefile;
	}

	@StringSetter(WAITING_TIME_ZONE_SHAPEFILE)
	public void setWaitingTimeZoneShapefile(String waitingTimeZoneShapefile) {
		this.waitingTimeZoneShapefile = waitingTimeZoneShapefile;
	}

	@StringGetter(WAITING_TIME_ZONE_IDENTIFIER_ATTRIBUTE)
	public String getWaitingTimeZoneIdentifierAttribute() {
		return waitingTimeZoneIdentifierAttribute;
	}

	@StringSetter(WAITING_TIME_ZONE_IDENTIFIER_ATTRIBUTE)
	public void setWaitingTimeZoneIdentifierAttribute(String waitingTimeZoneIdentifierAttribute) {
		this.waitingTimeZoneIdentifierAttribute = waitingTimeZoneIdentifierAttribute;
	}
}
