package ch.ethz.matsim.projects.astra_2018_002.shared_av.dynamics;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;

import org.matsim.api.core.v01.Id;
import org.matsim.api.core.v01.network.Link;
import org.matsim.contrib.dvrp.passenger.PassengerEngine;
import org.matsim.core.config.Config;
import org.matsim.core.mobsim.framework.MobsimAgent;
import org.matsim.core.mobsim.qsim.AbstractQSimPlugin;
import org.matsim.core.mobsim.qsim.interfaces.DepartureHandler;

import com.google.inject.AbstractModule;
import com.google.inject.Module;
import com.google.inject.Provides;
import com.google.inject.Singleton;

import ch.ethz.matsim.projects.astra_2018_002.shared_av.SharedAVModule;

public class AVModesQSimPlugin extends AbstractQSimPlugin {
	public AVModesQSimPlugin(Config config) {
		super(config);
	}

	public Collection<? extends Module> modules() {
		return Collections.singleton(new AbstractModule() {
			@Override
			protected void configure() {
			}

			@Provides
			@Singleton
			public AVDepartureHandler provideAVDepartureHandler(PassengerEngine passengerEngine) {
				return new AVDepartureHandler(passengerEngine);
			}
		});
	}

	public Collection<Class<? extends DepartureHandler>> departureHandlers() {
		return Arrays.asList(AVDepartureHandler.class);
	}

	static private class AVDepartureHandler implements DepartureHandler {
		private final PassengerEngine delegate;

		public AVDepartureHandler(PassengerEngine delegate) {
			this.delegate = delegate;
		}

		@Override
		public boolean handleDeparture(double now, MobsimAgent agent, Id<Link> linkId) {
			if (agent.getMode().equals(SharedAVModule.AV_POOL) || agent.getMode().equals(SharedAVModule.AV_TAXI)) {
				return delegate.handleDeparture(now, agent, linkId);
			}

			return false;
		}

	}
}
